import { ValidationOptions } from 'class-validator';
import { PropertyOptions } from '../core';
import { CustomValidateOptions } from './utils/custom-validator';
export type { CustomValidateOptions };
export declare type DateFormat = 'date' | 'date-time';
export declare const IsString: ({ maxLength, minLength, pattern, canBeEmpty, isEmail, isDate, customValidate, ...base }?: PropertyOptions<string, {
    canBeEmpty?: true | undefined;
    maxLength?: number | undefined;
    minLength?: number | undefined;
    pattern?: {
        regex: RegExp;
        message?: ValidationOptions['message'];
    } | undefined;
    isEmail?: true | undefined;
    isDate?: {
        format: DateFormat;
    } | undefined;
    customValidate?: CustomValidateOptions<unknown> | undefined;
}>) => PropertyDecorator;
