"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformHandlingOptional = void 0;
const class_transformer_1 = require("class-transformer");
function TransformHandlingOptional(config, transform) {
    return (0, class_transformer_1.Transform)((params) => {
        if (config.optional && params.value === undefined) {
            return params.value;
        }
        if (config.nullable && params.value === null) {
            return params.value;
        }
        if (params.value === null || params.value === undefined) {
            return new Error(`${params.key} does not exist`);
        }
        return transform(params);
    });
}
exports.TransformHandlingOptional = TransformHandlingOptional;
//# sourceMappingURL=transform-handling-optional.js.map